#include"head.v3.h"


void make_mesh (double x_min, double x_max, int num_points, int flag,
   double *x)
/* Fill array x[].
       INPUT:
   x_min - minimum value of x
   x_max - maximum value of x
   num_points - number of elements in x[]
   flag - points linearly (0) or logarithmically (1) separated
       OUTPUT:
   x[num_points] - array with x values
*/

{  double x_ ; // current value of x 
   double dx_lin, dx_log; // linear and log step for x
   if (num_points==0) {
      printf ("Error in make_mesh(). Number of points should not be 0.\n      Exit.\n"); exit (47);
   }
   if (num_points!=1) {
      if ((fabs((x_max-x_min)/x_max)<ACCURACY) ||
         ((x_max==0) && (x_min==0))
         ){
         printf ("Error in make_mesh(). Lower and higher boundary are too close\n         to each other. Exit.\n"); exit (48);
      }
   }
   if (num_points==1) {
      dx_lin = dx_log = 0;
   }
   else {
      // place limiting values in the right order:
      if (x_max<x_min) { double temp; SWITCH(x_max,x_min,temp);}
      // calculate step of the mesh:
      if ((int)flag==0) {dx_lin =(x_max-x_min)/(double)(num_points-1);}
      if ((int)flag==1) {dx_log =pow(x_max/x_min, 1./(double)(num_points-1));}
   }
   x_=x_min;
   for (int i=0; i<num_points; i++) { 
      x[i]=x_; // zapolnenie massiva znacheniy radiusov
      
      if ((int)flag==0) { // linear augmentation
        x_ += dx_lin;
      } else {
         if ((int)flag==1) {// log augmentation
            x_ *= dx_log;
	 } else {
	   printf ("Error in x_mesh()/simpson.c.\n	     flag=%.2f, must be 0 or 1. Exit.\n",(double)flag);
	 }
      }
   }
}// end of procedure

